#include "RegisterTypes.h"

#include <gdextension_interface.h>
#include <godot_cpp/core/defs.hpp>
#include <godot_cpp/godot.hpp>

#include "Editor/WSEditorPlugin.h"

using namespace godot;

void InitModule(ModuleInitializationLevel initLevel)
{
    if(initLevel == MODULE_INITIALIZATION_LEVEL_EDITOR)
    {
        ClassDB::register_class<WSEditorPlugin>();
        EditorPlugins::add_by_type<WSEditorPlugin>();
    }
}

void DeinitModule(ModuleInitializationLevel initLevel)
{
    // Anything?
}

extern "C"
{
	GDExtensionBool GDE_EXPORT InitExtension(GDExtensionInterfaceGetProcAddress getProcAddress, const GDExtensionClassLibraryPtr library, GDExtensionInitialization* initPtr)
	{
        // Boilerplate for registering a GDExtension with Godot.
        // Specify init and deinit functions.
		godot::GDExtensionBinding::InitObject initObject(getProcAddress, library, initPtr);
        initObject.register_initializer(InitModule);
        initObject.register_terminator(DeinitModule);
        
        // Indicates when/if this GDExtension gets initialized.
        // You might have an extension that only runs in Editor, etc.
        initObject.set_minimum_library_initialization_level(MODULE_INITIALIZATION_LEVEL_SCENE);
		return initObject.init();
	}
}